color findColor(float drawHeight){
   float widestPoint = findWidestPointOnCurve();
   float colorShift = random(-color_variation, color_variation);
   
  
   //Point is above widest portion of curve, so it is light
   if (drawHeight < widestPoint){
     float drawHeightRemapped = map(drawHeight, widestPoint, 1, 0, 1);
     float middleRed = constrain(controlP5.controller("Middle_Red").value() + colorShift, 0, 255);
     float middleGreen = constrain(controlP5.controller("Middle_Green").value() + colorShift, 0, 255);
     float middleBlue = constrain(controlP5.controller("Middle_Blue").value() + colorShift, 0, 255);
     
     float topRed = controlP5.controller("Top_Red").value();
     float topGreen = controlP5.controller("Top_Green").value();
     float topBlue = controlP5.controller("Top_Blue").value();
     
     color lineColor = color(lerpColor(color(middleRed, middleGreen, middleBlue), color(topRed,topGreen,topBlue), drawHeightRemapped));
     return lineColor;
   }
   //Point is below widest portion of curve, so it is dark
   else{
     float drawHeightRemapped = map(drawHeight, 0, widestPoint, 0, 1);
     
     float middleRed = controlP5.controller("Middle_Red").value();
     float middleGreen = controlP5.controller("Middle_Green").value();
     float middleBlue = controlP5.controller("Middle_Blue").value();
     
     float bottomRed = constrain(controlP5.controller("Bottom_Red").value() + colorShift, 0, 255);
     float bottomGreen = constrain(controlP5.controller("Bottom_Green").value() + colorShift, 0, 255);
     float bottomBlue = constrain(controlP5.controller("Bottom_Blue").value() + colorShift, 0, 255);
     
     color lineColor = lerpColor(color(bottomRed,bottomGreen,bottomBlue), color(middleRed, middleGreen, middleBlue), drawHeightRemapped);
     return lineColor;   
   }
}


//Finds the widest point on a curve
float findWidestPointOnCurve(){
   float currentWidestPoint = 0;
   float widestPointValue = 0;
   for(float i=0; i<=1; i+= 0.05){
     if (widestPointValue < bezierPoint(0, Shape_Weight_1X, Shape_Weight_2X, 0, i)){
       widestPointValue = bezierPoint(0, Shape_Weight_1X, Shape_Weight_2X, 0, i);
       currentWidestPoint = i; 
     }
   }
   
   return currentWidestPoint;
}
