void line_width(float newWidth){
   drawingEgg.lineWidth = newWidth; 
}

void egg_length(float newegg_length){
  egg_length = newegg_length;
  cam.lookAt(0, egg_length/2, 0); 
}

//Draws the background for the interface
void drawInterfaceExtras(){ 
  noStroke();
  fill(0);
  rect(0,0,width,75);
  
  fill(color(controlP5.controller("Top_Red").value(), controlP5.controller("Top_Green").value(), controlP5.controller("Top_Blue").value()));
  rect(405, 55, 60, 10);
  
  fill(color(controlP5.controller("Middle_Red").value(), controlP5.controller("Middle_Green").value(), controlP5.controller("Middle_Blue").value()));
  rect(535, 55, 60, 10);
  
  fill(color(controlP5.controller("Bottom_Red").value(), controlP5.controller("Bottom_Green").value(), controlP5.controller("Bottom_Blue").value()));
  rect(665, 55, 60, 10);
}

//Creates and sets up all interface controls
void createInterface(){
  controlP5 = new ControlP5(this);

  Controller mySlider = controlP5.addSlider("Shape_Weight_1X", 0, 500, 15.0, 10, 5, 100, 10);
  mySlider.setColorForeground((int)color(170,0,19));
  mySlider.setColorBackground((int)color(82,0,4));
  mySlider.setColorActive((int)color(252,0,32));
  
  mySlider = controlP5.addSlider("Shape_Weight_1Y", 0, 80, 0, 10, 20, 100, 10);
  mySlider.setColorForeground((int)color(170,0,19));
  mySlider.setColorBackground((int)color(82,0,4));
  mySlider.setColorActive((int)color(252,0,32));
  
  mySlider = controlP5.addSlider("Shape_Weight_2X", 0, 500, 185, 10, 35, 100, 10);
  mySlider.setColorForeground((int)color(11, 170, 0));
  mySlider.setColorBackground((int)color(0,82,0));
  mySlider.setColorActive((int)color(21,202,0));
  
  mySlider = controlP5.addSlider("Shape_Weight_2Y", 0, 80, 40, 10, 50, 100, 10);
  mySlider.setColorForeground((int)color(11, 170, 0));
  mySlider.setColorBackground((int)color(0,82,0));
  mySlider.setColorActive((int)color(21,202,0));
  
  controlP5.addSlider("egg_length", 10, 300, 100, 220, 5, 100, 10);
  controlP5.addSlider("lineNum", 3, 100, 20, 220, 20, 100, 10);
  controlP5.addSlider("line_width", 0, 10, 1, 220, 35, 100, 10);
  controlP5.addSlider("color_variation", 0, 255, 100, 220, 50, 100, 10);
  
  mySlider = controlP5.addSlider("Top_Red", 0, 255, 246, 405, 5, 60, 10);
  mySlider.setColorForeground((int)color(255,0,0));
  mySlider.setColorBackground((int)color(82,0,4));
  mySlider.setColorActive((int)color(252,0,32));
  
  mySlider = controlP5.addSlider("Top_Green", 0, 255, 234, 405, 20, 60, 10);
  mySlider.setColorForeground((int)color(0, 255, 0));
  mySlider.setColorBackground((int)color(0,82,0));
  mySlider.setColorActive((int)color(21,202,0));
  
  mySlider = controlP5.addSlider("Top_Blue", 0, 255, 178, 405, 35, 60, 10);
  mySlider.setColorForeground((int)color(0,0,255));
  mySlider.setColorBackground((int)color(0,54,82));
  mySlider.setColorActive((int)color(6,153,196));
  
  mySlider = controlP5.addSlider("Middle_Red", 0, 255, 204, 535, 5, 60, 10);
  mySlider.setColorForeground((int)color(255,0,0));
  mySlider.setColorBackground((int)color(82,0,4));
  mySlider.setColorActive((int)color(252,0,32));
  
  mySlider = controlP5.addSlider("Middle_Green", 0, 255, 185, 535, 20, 60, 10);
  mySlider.setColorForeground((int)color(0, 255, 0));
  mySlider.setColorBackground((int)color(0,82,0));
  mySlider.setColorActive((int)color(21,202,0));
  
  mySlider = controlP5.addSlider("Middle_Blue", 0, 255, 144, 535, 35, 60, 10);
  mySlider.setColorForeground((int)color(0,0,255));
  mySlider.setColorBackground((int)color(0,54,82));
  mySlider.setColorActive((int)color(6,153,196));
  
  mySlider = controlP5.addSlider("Bottom_Red", 0, 255, 90, 665, 5, 60, 10);
  mySlider.setColorForeground((int)color(255,0,0));
  mySlider.setColorBackground((int)color(82,0,4));
  mySlider.setColorActive((int)color(252,0,32));
  
  mySlider = controlP5.addSlider("Bottom_Green", 0, 255, 71, 665, 20, 60, 10);
  mySlider.setColorForeground((int)color(0, 255, 0));
  mySlider.setColorBackground((int)color(0,82,0));
  mySlider.setColorActive((int)color(21,202,0));
  
  mySlider = controlP5.addSlider("Bottom_Blue", 0, 255, 29, 665, 35, 60, 10);
  mySlider.setColorForeground((int)color(0,0,255));
  mySlider.setColorBackground((int)color(0,54,82));
  mySlider.setColorActive((int)color(6,153,196));
  
  instructions = new ControlP5(this);
  controlP5.addTextarea("mouse_instructions", "Left Click = draw/rotate (x postition determines vertical placement of line, y position determines speed of lines drawn.   Mouse Scroll = zoom in/out", 5, height-25, width, 15);
  controlP5.addTextarea("kbd_instructions", "\'i\' = Show/Hide Interface    \'h\' = Show/Hide Nest Hull    \'d\' = Switch between drawing mode and camera mode    \'c\' =Clear current egg", 5, height-15, width, 15);
  
}
